Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/AlgorithmBehaviorUnitTests/AlgorithmBehaviorUnitTests.csproj
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/AlgorithmBehaviorUnitTests/AlgorithmBehaviorUnitTests.csproj	(revision 9945)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/AlgorithmBehaviorUnitTests/AlgorithmBehaviorUnitTests.csproj	(revision 10026)
@@ -77,5 +77,4 @@
   <ItemGroup>
     <Compile Include="UnitTest2.cs" />
-    <Compile Include="UnitTest1.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="ConvexHullTest.cs" />
@@ -89,4 +88,8 @@
       <Project>{2533d1f9-f7f6-46cb-90d2-76d254e38dee}</Project>
       <Name>HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Analysis.SolutionCaching\3.3\HeuristicLab.Analysis.SolutionCaching-3.3.csproj">
+      <Project>{a05aa272-14ec-4422-ac70-c9ca42164441}</Project>
+      <Name>HeuristicLab.Analysis.SolutionCaching-3.3</Name>
     </ProjectReference>
     <ProjectReference Include="..\MIConvexHull\MIConvexHull.csproj">
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/AlgorithmBehaviorUnitTests/UnitTest1.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/AlgorithmBehaviorUnitTests/UnitTest1.cs	(revision 9945)
+++ 	(revision )
@@ -1,22 +1,0 @@
-﻿using HeuristicLab.Analysis.AlgorithmBehavior.Analyzers;
-using HeuristicLab.Encodings.PermutationEncoding;
-using Microsoft.VisualStudio.TestTools.UnitTesting;
-
-namespace AlgorithmBehaviorUnitTests {
-  [TestClass]
-  public class UnitTest1 {
-    [TestMethod]
-    public void TestPermutationWrapper() {
-      var rand = new HeuristicLab.Random.FastRandom();
-      var permutation1 = new Permutation(PermutationTypes.RelativeUndirected, 3000, rand);
-      var permutation2 = new Permutation(PermutationTypes.RelativeUndirected, 3000, rand);
-
-      PermutationWrapper wrapper = new PermutationWrapper();
-      wrapper.StorePartialPermutation(permutation1, permutation2);
-
-      var newPermutation2 = wrapper.GetPermutation();
-      PermutationEqualityComparer comp = new PermutationEqualityComparer();
-      Assert.IsTrue(comp.Equals(permutation2, newPermutation2));
-    }
-  }
-}
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/AlgorithmBehaviorUnitTests/UnitTest2.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/AlgorithmBehaviorUnitTests/UnitTest2.cs	(revision 9945)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/AlgorithmBehaviorUnitTests/UnitTest2.cs	(revision 10026)
@@ -1,4 +1,5 @@
 ﻿using System.Linq;
-using HeuristicLab.Analysis.AlgorithmBehavior.Analyzers;
+using HeuristicLab.Analysis.SolutionCaching;
+using HeuristicLab.Analysis.SolutionCaching.PermutationEncoding;
 using HeuristicLab.Encodings.PermutationEncoding;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
@@ -10,21 +11,20 @@
     public void TestPermutationSolutionDictionary() {
       var rand = new HeuristicLab.Random.FastRandom();
-      PermutationWrapperEqualityComparer comp = new PermutationWrapperEqualityComparer();
-      PermutationSolutionDictionary dict = new PermutationSolutionDictionary();
+      PermutationEqualityComparer comp = new PermutationEqualityComparer();
+      PermutationSolutionCache dict = new PermutationSolutionCache();
       int realDuplicates = 0;
       int noDuplicates = 0;
 
-      PermutationWrapper[] permutations = new PermutationWrapper[500];
+      Permutation[] permutations = new Permutation[500];
       for (int i = 0; i < permutations.Length; i += 2) {
         var p = new Permutation(PermutationTypes.RelativeUndirected, 21, rand);
-        var pw = new PermutationWrapper(p);
-        permutations[i] = pw;
-        permutations[i + 1] = pw;
+        permutations[i] = p;
+        permutations[i + 1] = p;
 
-        PermutationInformation pi = new PermutationInformation();
+        PermutationSolutionInformation pi = new PermutationSolutionInformation();
         pi.Generation = rand.Next(0, 100);
         pi.ProducedBy = ProducedBy.Mutation;
 
-        dict.Add(pw, pi);
+        dict.Add(p, pi);
       }
 