Index: branches/HeuristicLab.Problems.GPDL/HeuristicLab.Problems.GPDL.sln
===================================================================
--- branches/HeuristicLab.Problems.GPDL/HeuristicLab.Problems.GPDL.sln	(revision 9842)
+++ branches/HeuristicLab.Problems.GPDL/HeuristicLab.Problems.GPDL.sln	(revision 10031)
@@ -31,30 +31,76 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "Test", "Test\Test.csproj", "{94073310-27AB-4C93-8FDD-3D35824AE3F7}"
 EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Grammars-3.3", "HeuristicLab.Grammars\3.3\HeuristicLab.Grammars-3.3.csproj", "{A5452B63-B33B-4F9F-9E81-98B75EDB5612}"
+EndProject
 Global
 	GlobalSection(SolutionConfigurationPlatforms) = preSolution
 		Debug|Any CPU = Debug|Any CPU
+		Debug|x64 = Debug|x64
+		Debug|x86 = Debug|x86
 		Release|Any CPU = Release|Any CPU
+		Release|x64 = Release|x64
+		Release|x86 = Release|x86
 	EndGlobalSection
 	GlobalSection(ProjectConfigurationPlatforms) = postSolution
 		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Debug|x64.ActiveCfg = Debug|x64
+		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Debug|x64.Build.0 = Debug|x64
+		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Debug|x86.ActiveCfg = Debug|x86
+		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Debug|x86.Build.0 = Debug|x86
 		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Release|Any CPU.Build.0 = Release|Any CPU
+		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Release|x64.ActiveCfg = Release|x64
+		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Release|x64.Build.0 = Release|x64
+		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Release|x86.ActiveCfg = Release|x86
+		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Release|x86.Build.0 = Release|x86
 		{729B818F-E1D0-4C9D-915A-775B2A4B1D27}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{729B818F-E1D0-4C9D-915A-775B2A4B1D27}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{729B818F-E1D0-4C9D-915A-775B2A4B1D27}.Debug|x64.ActiveCfg = Debug|Any CPU
+		{729B818F-E1D0-4C9D-915A-775B2A4B1D27}.Debug|x86.ActiveCfg = Debug|Any CPU
 		{729B818F-E1D0-4C9D-915A-775B2A4B1D27}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{729B818F-E1D0-4C9D-915A-775B2A4B1D27}.Release|Any CPU.Build.0 = Release|Any CPU
+		{729B818F-E1D0-4C9D-915A-775B2A4B1D27}.Release|x64.ActiveCfg = Release|Any CPU
+		{729B818F-E1D0-4C9D-915A-775B2A4B1D27}.Release|x86.ActiveCfg = Release|Any CPU
 		{3F9E665A-3DCB-49C3-8806-0E47FC48EA52}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{3F9E665A-3DCB-49C3-8806-0E47FC48EA52}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{3F9E665A-3DCB-49C3-8806-0E47FC48EA52}.Debug|x64.ActiveCfg = Debug|x64
+		{3F9E665A-3DCB-49C3-8806-0E47FC48EA52}.Debug|x64.Build.0 = Debug|x64
+		{3F9E665A-3DCB-49C3-8806-0E47FC48EA52}.Debug|x86.ActiveCfg = Debug|x86
+		{3F9E665A-3DCB-49C3-8806-0E47FC48EA52}.Debug|x86.Build.0 = Debug|x86
 		{3F9E665A-3DCB-49C3-8806-0E47FC48EA52}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{3F9E665A-3DCB-49C3-8806-0E47FC48EA52}.Release|Any CPU.Build.0 = Release|Any CPU
+		{3F9E665A-3DCB-49C3-8806-0E47FC48EA52}.Release|x64.ActiveCfg = Release|x64
+		{3F9E665A-3DCB-49C3-8806-0E47FC48EA52}.Release|x64.Build.0 = Release|x64
+		{3F9E665A-3DCB-49C3-8806-0E47FC48EA52}.Release|x86.ActiveCfg = Release|x86
+		{3F9E665A-3DCB-49C3-8806-0E47FC48EA52}.Release|x86.Build.0 = Release|x86
 		{C3A2E1C9-9677-4992-A1B7-7B38CDB82FEF}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{C3A2E1C9-9677-4992-A1B7-7B38CDB82FEF}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{C3A2E1C9-9677-4992-A1B7-7B38CDB82FEF}.Debug|x64.ActiveCfg = Debug|Any CPU
+		{C3A2E1C9-9677-4992-A1B7-7B38CDB82FEF}.Debug|x86.ActiveCfg = Debug|Any CPU
 		{C3A2E1C9-9677-4992-A1B7-7B38CDB82FEF}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{C3A2E1C9-9677-4992-A1B7-7B38CDB82FEF}.Release|Any CPU.Build.0 = Release|Any CPU
+		{C3A2E1C9-9677-4992-A1B7-7B38CDB82FEF}.Release|x64.ActiveCfg = Release|Any CPU
+		{C3A2E1C9-9677-4992-A1B7-7B38CDB82FEF}.Release|x86.ActiveCfg = Release|Any CPU
 		{94073310-27AB-4C93-8FDD-3D35824AE3F7}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{94073310-27AB-4C93-8FDD-3D35824AE3F7}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{94073310-27AB-4C93-8FDD-3D35824AE3F7}.Debug|x64.ActiveCfg = Debug|Any CPU
+		{94073310-27AB-4C93-8FDD-3D35824AE3F7}.Debug|x86.ActiveCfg = Debug|Any CPU
 		{94073310-27AB-4C93-8FDD-3D35824AE3F7}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{94073310-27AB-4C93-8FDD-3D35824AE3F7}.Release|Any CPU.Build.0 = Release|Any CPU
+		{94073310-27AB-4C93-8FDD-3D35824AE3F7}.Release|x64.ActiveCfg = Release|Any CPU
+		{94073310-27AB-4C93-8FDD-3D35824AE3F7}.Release|x86.ActiveCfg = Release|Any CPU
+		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Debug|x64.ActiveCfg = Debug|x64
+		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Debug|x64.Build.0 = Debug|x64
+		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Debug|x86.ActiveCfg = Debug|x86
+		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Debug|x86.Build.0 = Debug|x86
+		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Release|Any CPU.Build.0 = Release|Any CPU
+		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Release|x64.ActiveCfg = Release|x64
+		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Release|x64.Build.0 = Release|x64
+		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Release|x86.ActiveCfg = Release|x86
+		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Release|x86.Build.0 = Release|x86
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution